#include <boost/date_time/posix_time/posix_time.hpp>
#include <iostream>

void* __cdecl operator new(size_t size)
{
  void* res = malloc(size);
  //printf("%u return %p\n", size, res);
 return res;
}

void __cdecl operator delete(void* p)
{
 free(p);
}

const int DATA_SIZE  = 512;
const int ITEM_CNT   = 500000; // 100000;
const int LOOP_CNT   = 100;

class Item
{
public:
  Item()          { data = NULL; };
  virtual ~Item() { if (data != NULL) delete data; data = NULL; };
  char* data;
};

typedef std::map<int, Item> ItemMap;

void write(ItemMap& itemMap, int count = 5)
{
  ItemMap::iterator prev = itemMap.begin();
  for (ItemMap::iterator it = itemMap.begin(); it != itemMap.end(); it++)
  {
    char* p1 = (char*)&(*prev);
    char* p2 = (char*)&(*it);
    int   diff = p2 - p1;
    std::cout << diff << " ";
    
    p1 = (char*)&(prev->first);
    p2 = (char*)&(it->first);
    diff = p2 - p1;
    std::cout << diff << std::endl;
    prev = it;

    if (count-- <= 0) break;
  }
}

void test(ItemMap& itemMap)
{
  write(itemMap); // gilgil temp
  boost::posix_time::ptime begTick(boost::posix_time::microsec_clock::local_time());
  for (int i = 0; i < LOOP_CNT; i++)
    for (int key = 0; key < ITEM_CNT; key++)
    {
      if (itemMap.find(key) == itemMap.end()) std::cout << "NULL" << std::cout;
    }
  boost::posix_time::ptime endTick(boost::posix_time::microsec_clock::local_time());
  std::cout << boost::posix_time::to_simple_string(endTick - begTick) << std::endl;
}

int main()
{
  malloc(3);
  ItemMap itemMap;
  int i;

/*
  itemMap.clear();
  std::cin >> i;
  for (int key = 0; key < ITEM_CNT; key++)
  {
    Item item;
    itemMap[key] = item;
    itemMap[key].data = new char[DATA_SIZE];
  }
  test(itemMap);
*/
///*
  itemMap.clear();
  std::cin >> i;
  for (int key = 0; key < ITEM_CNT; key++)
  {
    Item item;
    itemMap[key] = item;
  }
  for (ItemMap::iterator it = itemMap.begin(); it != itemMap.end(); it++)
  {
    Item& item = it->second;
    item.data = new char[DATA_SIZE];
  }
  test(itemMap);
//*/
}